#include	"kbheader.h"
#undef		USE_BLK
#define		USE_BLK
#define		USE_WORD
#undef		USE_WORD
/**/
#ifdef	USE_BLK
typedef	struct		BLOCK	{
	char	*b_base;	/* base of block */
	char	*b_used;	/* used through here */
	NOSIGN	b_left;		/* btyes left */
	NOSIGN	b_size;		/* size of block */
	}	BLOCK;
BLOCK	block;
#endif	/*USE_BLK*/
typedef struct 		TNODE 	{
	char			*twrd;
	struct	TNODE	*tupr;
	struct	TNODE	*tlwr;
	}	TNODE;
/**/
TNODE	*troot;
TNODE	*tsave;
NOSIGN	tflag;
/**/
#define	T_NONODE	1
#define	T_NODUPE	2
/**/
#ifdef	CAN_PROTO
struct TNODE *tgen(void);
struct TNODE *tadd(char *,struct TNODE *);
void tprt(struct TNODE *);
void tfree(struct TNODE *);
void tclr(struct TNODE *);
void tfilter(char *);
char *blk_strsave(char *);
char *blk_malloc(NOSIGN);
struct BLOCK *getmemblk(struct BLOCK *);
char *blk_free(char *);
#else	/*CAN_PROTO*/
struct TNODE *tgen();
struct TNODE *tadd();
void tprt();
void tfree();
void tclr();
void tfilter();
char *blk_strsave();
char *blk_malloc();
struct BLOCK *getmemblk();
char *blk_free();
#endif	/*CAN_PROTO*/
/**/
TNODE *
tgen()
{
	auto	TNODE	*tx;
#ifdef	USE_BLK
	tx = (TNODE *) blk_malloc( sizeof( TNODE ) );
#else	/*USE_BLK*/
	tx = (TNODE *) malloc( sizeof( TNODE ) );
#endif	/*USE_BLK*/
	if(tx == (TNODE *) NULL)	tflag |= T_NONODE;
#ifdef	USE_BLK
#else	/*USE_BLK*/
	else	memset((char *) tx, 0, sizeof(TNODE *));
#endif	/*USE_BLK*/
	return(tx);
}
/**/
TNODE *
tadd(is,tr)
char	*is;
TNODE	*tr;
{
	auto	int		ret;
	if(tr == (TNODE *) NULL)	{
		auto	TNODE	*tx;
		tx = tgen();
		if(tx)	{
#ifdef	USE_BLK
			tx->twrd = blk_strsave(is);
#else	/*USE_BLK*/
			tx->twrd = strdup(is);
#endif	/*USE_BLK*/
			if(tx->twrd == NULL) tflag |= T_NODUPE;
			}
		if(tflag == 0)	tr = tx;
		}
	else	{
		ret = *is - *tr->twrd;
		if(ret == 0)	ret = strcmp(is,tr->twrd);
		if(ret == 0)	;			/* repeat */
		else
		if(ret < 0)	tr->tlwr = tadd(is,tr->tlwr);
		else		tr->tupr = tadd(is,tr->tupr);
		}
	return(tr);
}
void
tprt(tr)
TNODE	*tr;
{
	if(tr)	{
		tprt(tr->tlwr);
		puts(tr->twrd);
		tprt(tr->tupr);
		}
	return;
}
void
tfree(tr)
TNODE	*tr;
{
	tclr(tr);
#ifdef	USE_BLK
	blk_free(NULL);
#else	/*USE_BLK*/
#endif	/*USE_BLK*/
}
void
tclr(tr)
TNODE	*tr;
{
	if(tr)	{
		tclr(tr->tlwr);
		tclr(tr->tupr);
#ifdef	USE_BLK
#else	/*USE_BLK*/
		if(tr->twrd) free(tr->twrd);
		free(tr);
#endif	/*USE_BLK*/
		}
	return;
}
void
tfilter(ws)
char	*ws;
{
#ifdef	USE_BLK
	if( block.b_base == NULL)	getmemblk(&block);
#endif	/*USE_BLK*/
	if(ws == NULL)	{
			tprt(troot);
			tfree(troot);
			tsave = troot = (TNODE *) NULL;
			tflag = 0;
			return;
			}
	tflag = 0;
	while(1)	{
		troot = tadd(ws,troot);
		if(tflag)	{
			tprt(troot);
			tfree(troot);
			tsave = troot = (TNODE *) NULL;
			tflag = 0;
			}
		else	break;
	}
	return;
}
#ifdef	USE_BLK
char	*
blk_strsave(is)
char	*is;
{
	auto	NOSIGN	ls = strlen(is) + 1;
	auto	char	*rx = blk_malloc(ls);
	if(rx)	strcpy(rx,is);
	return(rx);
}
char	*
blk_malloc(size)
NOSIGN	size;
{
	auto	char	*rx = NULL;
#ifdef	USE_WORD
	size = (size % 2) ? (size + 1) : size;
#endif	/*USE_WORD*/
	if( size <= block.b_left)	{
		block.b_left -= size;
		rx = block.b_used;
		memset( rx, 0, size );
		block.b_used += size;
		}
#ifdef	DEBUG
	fprintf(stderr,"b_base %5u ",block.b_base);
	fprintf(stderr,"b_used %5u ",block.b_used);
	fprintf(stderr,"b_left %5u ",block.b_left);
	fprintf(stderr,"rx     %5u ",rx);
	fprintf(stderr,"\n");
#endif
	return( rx );
}
BLOCK	*
getmemblk(bx)
BLOCK	*bx;
{
	auto	long		want;
	auto	long		size;
	auto	long		blok;
/**/
	if(sizeof(char *) == 2)	want = 1L << 16;
	else
	if(sizeof(char *) == 4)	want = 1L << 20;
	else					abort();
	blok = want / 8;
/**/
	size = blok;
	while(size <= want)	{
		bx->b_base = malloc( (unsigned) size );
		if(bx->b_base != NULL)	{
			free( bx->b_base);
			size += blok;
			}
		else	break;
		}
/**/
	if(bx->b_base)	free(bx->b_base);
	size -= blok;
/**/
	bx->b_base = malloc( size );
/**/
	bx->b_used = bx->b_base;
	bx->b_left = bx->b_size = size;
/**/
#ifdef	DEBUG
	fprintf(stderr,"bx->b_base %5u ",bx->b_base);
	fprintf(stderr,"bx->b_size %5u ",bx->b_size);
	fprintf(stderr,"\n");
	query(stderr);
#endif
	return( bx );
}
char	*
blk_free(is)
char	*is;
{
	block.b_used = block.b_base;
	block.b_left = block.b_size;
	memset(block.b_base, 0, block.b_size);
	return(NULL);
}
#endif	/*USE_BLK*/
