/*COMLIB*/
/*
	copy a file using blocked binary routines;  the new file
	has the same [am]time as the original; interrupts are
	ignored
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include	<signal.h>
/*EXTERN*/
extern		KENV		kenv;
/**/
filecopy(os,is)	/* copy is to os */
char	*os;
char	*is;
{
	return(fcopy(os,is));
}
/**/
fcopy(os,is)	/* copy is to os */
char	*os;
char	*is;
{
	auto	FUNCP	sigint;
	auto	FUNCP	sighup;
	auto	FUNCP	sigbrk;
	auto	FILE	*ofp = (FILE*) NULL;
	auto	FILE	*ifp = (FILE*) NULL;
	auto	int		cno;
	auto	int		cni;
	auto	char	*buf;
	auto	long	fsiz;
	auto	int		siz = bufsiz();
	auto	char	*rm = "rb";
	auto	char	*wm = "wb";
/**/
	if(!kenv.dosdos)	rm[1] = wm[1] = ZERO;
/**/
	diskreset();
/**/
	fsiz = filesize(is);
/**/
	if(fsiz < 0L)	{
		errmsg("fcopy <bad file> '%s'\n",is);
		return(-1);
		}
/**/
	gut(is);
/**/
	if(inisout(os,is))	return(-2);
/**/
	if(!(ofp = efopen(os,wm)))	return(-3);
	if(!(ifp = efopen(is,rm)))	return(-3);
/**/
	buf = emalloc(siz,"fcopy");
/**/
	sigint = signal(SIGINT,SIG_IGN);
#ifdef	MSDOS
#else	/*MSDOS*/
	sighup = signal(SIGHUP,SIG_IGN);
#endif	/*MSDOS*/
/**/
	fsiz = 0L;
/**/
	while((cni = fread(buf,1,siz,ifp)) >= 1)	{
		cno = fwrite(buf,1,cni,ofp);
		fsiz += cno;
		if(cno != cni)	{
			errmsg("fcopy <write error>\n");
			break;
			}
		}
/**/
	ofp = xfclose(ofp);
	ifp = xfclose(ifp);
/**/
#ifdef	__TURBOC__
	signal(SIGINT,(void (*)()) sigint);
#else	/*__TURBOC__*/
	signal(SIGINT,sigint);
#endif	/*__TURBOC__*/
#ifdef	MSDOS
#else	/*MSDOS*/
	signal(SIGHUP,sighup);
#endif	/*MSDOS*/
/**/
	buf = free_if(buf);
/**/
	sut(os);
/**/
	return(0);
}
inisout(os,is)
char	*os;
char	*is;
{
	auto		int		err = 0;
/**/
	if(filesize(os) < 0)	return(0);
/**/
	if(kenv.dosdos)	{
		if(filesize(os) == filesize(is) &&
			filemraw(os) == filemraw(is))	err = 1;
		}
	else
	if(fileinode(os) == fileinode(is))		err = 1;
	if(err)	{
		errmsg("fcopy <input == output>\n");
		}
	return(err);
}
#ifdef	TEST
KENV	kenv;
main()
{
	auto	char	ls[BLKSIZ];
	auto	char	os[BLKSIZ];
	auto	char	is[BLKSIZ];
/**/
	kenv.dosdos = isdos();
/**/
	disnme(kenv.pname = "filecopy");
	puts(kenv.pname);
/**/
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	case	'q':	fclose(stdin);
					break;
	case	'!':	system(ls+1);
					break;
	case	'<':	strcpy(is,strcnd(ls+1));
					break;
	case	'>':	strcpy(os,strcnd(ls+1));
					break;
	case	'#':	fcopy(os,is);
					break;
	default:		puts("<in >out !cmd q #");
					break;
	}
	exit(0);
}
terror(ty)
{
	errmsg("terror(%u)\n",ty);
	return(ty);
}
#endif
