#define		TAR_EXTERN		/**/
#include	"copyrigh.h"
#include	"pdtar.h"
#include	"pdproto.h"
/**/
#ifdef		MSDOS
#define		DEVTTY		"con"
#define		TMPDIR		"."
#else		/*MSDOS*/
#define		DEVTTY		"/dev/tty"
#define		TMPDIR		"/usr/tmp"
#endif		/*MSDOS*/
/**/
#include	<signal.h>
/**/
int		file_list = 0;
/**/
/*EXTERN*/
#ifdef	CAN_PROTO
#ifdef	__TURBOC__
#else
extern char *getenv(char *);
#endif
#else
extern char *getenv();
#endif
/**/
void
terror(ty)		/* trap errors, clean up */
int		ty;
{
	cleanup(ty);
	exit(ty);
	return;		/* LINT */
}
void
cleanup(ty)		/* remove linked files */
int		ty;
{
	xfclose(lfp);
	xfclose(xfp);
	unlink(lfn);
	unlink(xfn);
	return;		/* LINT */
}
/**/
main(argc,argv)
int		argc;
char	*argv[];
{
	static	char	*here = "main";
	auto	int		td;
#ifndef	__TURBOC__
	extern	char	*malloc();
#endif	/*__TURBOC__*/
/**/
#ifdef	MSDOS
	setcbrk(1);
#endif	/*MSDOS*/
/**/
#ifdef	SUN
	stdrpt = fdopen(fileno(stderr),"w");
	stdask = fdopen(fileno(stderr),"r");
#else	/*SUN*/
	stdrpt = fopen(DEVTTY,"w");
	stdask = fopen(DEVTTY,"r");
#endif	/*SUN*/
	if(stdask == (FILE *) NULL || stdrpt == (FILE *) NULL)	{
		where(here);
		perror(DEVTTY);
		exit(FUBAR);
		}
/**/
	if(getenv("TMPDIR") == NULL)	strcpy(tmpdir,TMPDIR);
	else							strcpy(tmpdir,getenv("TMPDIR"));
/**/
	lfp = opentmp(lfn,"w+",tmpdir,"pdXXXXXX.tmp");
	xfp = opentmp(xfn,"w+",tmpdir,"pdXXXXXX.tmp");
	setbuf(xfp,malloc(BUFSIZ));
	setbuf(lfp,malloc(BUFSIZ));
/*
	when creating an archive, lfp is a table of linked files and xfp
	is the segmentation instructions for making the archive.

	when extracting or listing, lfp is the files to be listed or
	extracted and xfp is the files actually extracted.
*/
/**/
	signal(SIGINT,terror);
#ifdef	__TURBOC__
	setcbrk(1);
	ctrlbrk(terror);
#endif
/**/
	setopt(argc,argv);
/**/
#ifdef	__TURBOC__
/*
|	without this code, the first call to stat() always gives the wrong
|	time, off by the time zone differential (?)
*/
	{
	auto	long	now;
	time(&now);
	ctime(&now);
	}
#endif	/*__TURBOC__*/
/**/
	if(oswitch.pauseit)	{
		fprintf(stderr,"\007<INSERT FIRST FLOPPY, THEN CR>");
		while(getc(stdin) != '\n')	;
		}
/**/
	if(oswitch.archive)	tar_write(T_OPEN);
	else
	if(oswitch.extract)	tar_read(T_OPEN);
	else
	if(oswitch.listing)	{
		fclose(stdrpt);
		stdrpt = stdout;
		tar_read(T_OPEN);
		}
/**/
	getlist(argc,argv);
/**/
	if(oswitch.listing)		extract();
	else
	if(oswitch.extract)		extract();
	else
	if(oswitch.archive)		create();
	else
	if(oswitch.estimate)	estimate();
	else					hint(stderr);
/**/
	cleanup(0);
	return(0);	/* do nothing */
}
setopt(argc,argv)
int		argc;
char	*argv[];
{
	static	char	*here = "setopt";
	auto	int		ix;
	auto	int		jx;
	auto	char	*px;
/**/
	device.ifd = 0;
	device.ofd = 1;
	numargs = argc;
	argvect = argv;
	device.bpr = device.bpw = NBUF;	/* may be reset by 'V' option */
	rfunc = sysread;
	wfunc = syswrite;
	oswitch.usemask = 1;
	oswitch.useperm = 1;
	oswitch.usetime = 1;
	oswitch.absnme = 1;
	oswitch.convert = 1;
	afn[0] = 0;
/**/
	for(ix = 1; ix < argc; ix++)	{
		px = argv[jx = ix];
		if(strcmp(px,"-C") == 0)	break;
		if(strcmp(px,"-F") == 0)	break;
		if(*px++ != '-')			break;
		while(ix == jx && *px != 0)	switch(*px++)	{
			case	'H':
			case	'h':
				hint(stdout);
				terror(0);
				break;
			case	'n':
				oswitch.nottape = 1;
				break;
			case	'R':
				oswitch.recover = 1;
				break;
			case	'T':
				oswitch.convert = 0;
				break;
			case	't':
				oswitch.listing = 1;
				break;
			case	'L':
				oswitch.copylink = 1;
				break;
			case	'A':
				oswitch.absnme = 0;
				break;
			case	'P':
				if(*px == 0)	px = argv[++ix];
				oswitch.pathskip = atoi(px);
				oswitch.pathskip = oswitch.pathskip ? oswitch.pathskip : 1;
				px = digiskip(px);
				break;
			case	'Q':
				oswitch.pauseit = 1;
				break;
			case	'E':
				oswitch.estimate = 1;
				break;
			case	'f':	
				strcpy(afn,argv[++ix]);
				if(afn[1] == ':' && afn[2] == ZERO)	{
					setdrive(afn[0]);
					afn[0] = 0;
					}
				break;
			case	'K':
				oswitch.capital = 1;
				break;
			case	'k':
#ifdef	MSDOS
				oswitch.rawio = 1;
#endif	/*MSDOS*/
				if(*px == 0)	px = argv[++ix];
				device.bpf = atoi(px);
				device.bpf <<= 1;
				setspt(device.bpf);
				px = digiskip(px);
				oswitch.nottape = 1;
				break;
			case	'x':
				oswitch.extract = 1;
				break;
			case	'G':
				oswitch.usegenr = 1;
				break;
			case	'N':
				oswitch.usenewr = 1;
				break;
			case	'Z':
				oswitch.unhinge = 1;
				break;
			case	'U':
				oswitch.usemask = 0;
				break;
			case	'p':
				oswitch.useperm = 0;
				break;
			case	'm':
				oswitch.usetime = 0;
				break;
			case	'c':
				oswitch.archive = 1;
				break;
			case	'v':
				oswitch.verbose += 1;
				break;
			default:
				if(isdigit(px[-1]))	{
					px -= 1;
					tardefs(atoi(px));
					px = digiskip(px);
					}
				else	{
					where(here);
					fprintf(stderr,
						"tar: setopt <bad option> '%c'\n",px[-1]);
					terror(FUBAR);
					}
				break;
			}
		}
	if(chkopt())	terror(FUBAR);
/*	NULL args to avoid confusing getlist() */
	jx = ix;
	for(ix = 1; ix < jx; ix++)	argv[ix] = NULL;
/**/
	return(0);
}
chkopt()	/* check option logic here */
{
	static	char	*here = "chkopt";
	auto	int		killme = 0;
	auto	int		mc;
/* 	check for at one and only one function */
	mc = oswitch.estimate + oswitch.listing + oswitch.extract + oswitch.archive;
	if(mc == 0 || mc > 1)	{
		where(here);
		fprintf(stderr,"<one and only one from -c -E -t -x>\n");
		killme += 1;
		}
	mc = oswitch.usenewr + oswitch.usegenr;
	if(mc > 1)	{
		where(here);
		fprintf(stderr,"<either -G or -N, not both>\n");
		killme += 1;
		}
	if(oswitch.usegenr && oswitch.listing)	{
		where(here);
		fprintf(stderr,"<-G is not valid with -t>\n");
		killme += 1;
		}
/*	estimate without disk size is illogical */
	if(oswitch.estimate && device.bpf == 0)	{
		where(here);
		fprintf(stderr,"<-E requires -k>\n");
		killme += 1;
		}
/*	so too is rawio without disk size */
	if(oswitch.rawio && device.bpf == 0)	{
		where(here);
		fprintf(stderr,"<rawio io requires -k>\n");
		killme += 1;
		}
/*	has an archive been specified */
	if(!oswitch.rawio && strlen(afn) <= 0)	{
		where(here);
		fprintf(stderr,"<no archive file specified>\n");
		killme += 1;
		}
/**/
	if(killme)	hint(stderr);
/**/
	return(killme);
}
void
getlist(argc,argv)	/* scan command line for list options */
int		argc;
char	*argv[];
{
	static	char	*here = "getlist";
	auto	int		ix;
	auto	char	*isx;
	auto	struct	stat	sb;
	auto	char	cwd[NAMSIZ];
	auto	int		must_cwd = 0;
	extern	char	*getcwd();
/*
	the process of building the file list diddles the current
	directory if the -C command is used.  getcwd() and save to
	restore after building the file list.
*/
/**/
	if(oswitch.archive && getcwd(cwd,NAMSIZ) == NULL)	{
		where(here);
		fprintf(stderr,"<getcwd failed>\n");
		terror(FUBAR);
		}
/**/
	for(ix = 1; ix < argc; ix++)	{
		if(argv[ix] == NULL)		continue;
		if(*argv[ix] == '-')		{
			isx = argv[ix] + 1;
			while(*isx != 0) switch(*isx++) {
				case	'F':
					ix += 1;
					readlist(argv[ix]);
					break;
				case	'C':
					if(oswitch.listing || oswitch.extract)	{
						where(here);
						fprintf(stderr,"<-C valid only with -c or -E>\n");
						terror(FUBAR);
						}
					ix += 1;
					must_cwd += 1;
#ifdef	CHDIR
					if(chdir(argv[ix]) < 0)	{
						where(here);
						perror(argv[ix]);
						terror(FUBAR);
						}
#else	/*CHDIR*/
					if(access(argv[ix],0))	{
						where(here);
						fprintf(stderr,"<cannot cd> '%s'\n",argv[ix]);
						terror(FUBAR);
						}
#endif	/*CHDIR*/
					{
					auto	char	ws[NAMSIZ];
					sprintf(ws,"C %s",argv[ix]);
					saver(ws);
					if(!argv[ix+1])	{
						where(here);
						fprintf(stderr,"<assuming . for -C>\n");
						saver(".");
						}
					}
					break;
				default:
					break;
				}
			}
		else	saver(argv[ix]);
		}
	if(file_list == 0 && (oswitch.estimate || oswitch.archive))	{
		where(here);
		fprintf(stderr,"<no files or directories specified>\n");
		terror(FUBAR);
		}
/**/
	if(must_cwd && chdir(cwd))	{
		where(here);
		fprintf(stderr,"<cd failed> '%s'\n",cwd);
		terror(FUBAR);
		}
	return;
}
void
saver(is)
char	*is;
{
/*
|	for making an archive, we expand any items on the command line or in
|	an F list.  for extraction, we just save the literal items.
*/
	auto	char	fn[NAMSIZ];
	file_list += 1;
	strcpy(fn,is);
	if(oswitch.archive || oswitch.estimate)	scanfile(fn);
	else									savelist(fn);
	return;
}
void
savelist(is)	/* save the items given on the command line */
char	*is;
{
	fprintf(lfp,"%s\n",is);
	return;
}
void
readlist(is)	/* read list from -F option */
char	*is;
{
	static	char	*here = "readlist";
	auto	FILE	*fp = efopen(is,"r",here);
	auto	char	ls[NAMSIZ];
/**/
	nullassign(is,here);
/**/
	if(fp == (FILE *) NULL)			terror(FUBAR);
/**/
	while(fgets(ls,NAMSIZ-1,fp))	{
		saver(strcnd(ls));
		}
/**/
	fclose(fp);
/**/
	return;
}
#ifdef	KLUDGE
FILE 	*
workfile()
{
}
char	*
getfile()
{
}
#endif
#ifdef	DEBUG
cmdlst(argc,argv,is)
int		argc;
char	*argv[];
char	*is;
{
	auto	NOSIGN	ix;
	for(ix = 1; ix < argc; ix++)	{
		if(argv[ix]) printf("%s %d %s\n",is,ix,argv[ix]);
		}
	return;
}
#endif
nullassign(os,is)
char	*os;
char	*is;
{
	if(os == NULL)	{
		fprintf(stderr,"%s <null assign>\n",is);
		terror(FUBAR);
		}
	return(FUBAR);
}
#ifdef	__MSDOS__
#else	/*__MSDOS__*/
#ifdef	M_XENIX
#define	SYSV
#endif	/*M_XENIX*/
#ifndef	SYSV
char	*
getcwd(os,nc)
char	*os;
int	nc;
{
	extern	char	*getwd();
	auto	char	ws[BUFSIZ];
	auto	char	*ds;
	auto	int	lds;
	os[0] = 0;
	ds = getwd(ws);
	if(ds == NULL)	return(NULL);
	lds = strlen(ds);
	if(lds < nc)	return(strcpy(os,ds));
	return(NULL);
}
#endif	/*SYSV*/
#endif	/*__MSDOS__*/
